#!/bin/bash

PACKAGE_NAME=`dpkg -l | grep nvidia  | grep "binary" | awk '{print $2}'`

link_for_nvidia() {
	##echo "Lning nvidia link for NV"
	gl_conf=` cat /etc/alternatives/i386-linux-gnu_gl_conf `
	case $gl_conf in
		*"nvidia"*)
			#have, do nothing
		;;
		*)
			#none, do link for nv
			##echo "do link"
			#sh link-nvidia-etc.shh
			ln -s /usr/share/$PACKAGE_NAME/glamor.conf /etc/alternatives/glamor_conf
			rm -f /etc/alternatives/i386-linux-gnu_gl_conf
			ln -s /usr/lib/$PACKAGE_NAME/ld.so.conf /etc/alternatives/i386-linux-gnu_gl_conf
			ln -s /usr/share/$PACKAGE_NAME/$PACKAGE_NAME.grub-gfxpayload /etc/alternatives/i386-linux-gnu_grub_fb_blacklist
			rm -f /etc/alternatives/i386-linux-gnu_xorg_extra_modules
			ln -s /usr/lib/$PACKAGE_NAME/xorg /etc/alternatives/i386-linux-gnu_xorg_extra_modules
			ln -s /usr/lib/$PACKAGE_NAME/alt_ld.so.conf /etc/alternatives/x86_64-linux-gnu_gl_conf
			ldconfig
			# Update the grub gfxpayload blacklist
			if which update-grub-gfxpayload >/dev/null 2>&1; then
				update-grub-gfxpayload
			fi
			# Remove any quirks for the driver
			if [ `which quirks-handler` ]; then
    				quirks-handler -e $PACKAGE_NAME -v
			fi
			##echo "done"
		;;
	esac
}

rm_nvidia_ln() {
	##echo "rming nvidia link"
	gl_conf=` cat /etc/alternatives/i386-linux-gnu_gl_conf `
	case $gl_conf in
		*"nvidia"*)
			#have, do rm nvidia ln
			##echo "rm link"
			#sh rm-nvidia-etc.sh
			rm -f /etc/alternatives/glamor_conf
			rm -f /etc/alternatives/i386-linux-gnu_gl_conf
			ln -s /usr/lib/i386-linux-gnu/mesa/ld.so.conf /etc/alternatives/i386-linux-gnu_gl_conf
			rm -f /etc/alternatives/i386-linux-gnu_grub_fb_blacklist
			rm -f /etc/alternatives/i386-linux-gnu_xorg_extra_modules
			ln -s /usr/lib/i386-linux-gnu/xorg/x11-extra-modules /etc/alternatives/i386-linux-gnu_xorg_extra_modules
			rm -f /etc/alternatives/x86_64-linux-gnu_gl_conf
			ldconfig
			# Update the grub gfxpayload blacklist
			if which update-grub-gfxpayload >/dev/null 2>&1; then
			    update-grub-gfxpayload
			fi
			# Remove any quirks for the driver
			if [ `which quirks-handler` ]; then
			    quirks-handler -d $PACKAGE_NAME -v
			fi
			##echo "done"
		;;
		*)
			#none, do nothing
		;;
	esac
}

fun_check_pci() {
	nvid=`lspci | grep -i vga | grep -i NVIDIA` 
	[ -n "$nvid" ] && link_for_nvidia || rm_nvidia_ln
}

case $PACKAGE_NAME in
	*"nvidia"*)
		fun_check_pci
	;;
	*)
		##echo "no nvidia package"
	;;
esac

